Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 55)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 125)
@@ -1,37 +1,37 @@
 /* The copyright in this software is being made available under the BSD
- * License, included below. This software may be subject to other third party
- * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- *  * Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- *  * Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
- *    be used to endorse or promote products derived from this software without
- *    specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
- * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
- * THE POSSIBILITY OF SUCH DAMAGE.
- */
+* License, included below. This software may be subject to other third party
+* and contributor rights, including patent rights, and no such rights are
+* granted under this license.  
+*
+* Copyright (c) 2010-2013, ITU/ISO/IEC
+* All rights reserved.
+*
+* Redistribution and use in source and binary forms, with or without
+* modification, are permitted provided that the following conditions are met:
+*
+*  * Redistributions of source code must retain the above copyright notice,
+*    this list of conditions and the following disclaimer.
+*  * Redistributions in binary form must reproduce the above copyright notice,
+*    this list of conditions and the following disclaimer in the documentation
+*    and/or other materials provided with the distribution.
+*  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
+*    be used to endorse or promote products derived from this software without
+*    specific prior written permission.
+*
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+* THE POSSIBILITY OF SUCH DAMAGE.
+*/
 
 /** \file     TAppEncTop.cpp
-    \brief    Encoder application class
+\brief    Encoder application class
 */
 
@@ -75,36 +75,42 @@
 Void TAppEncTop::xInitLibCfg()
 {
+  TComVPS* vps = m_acTEncTop[0].getVPS();
+
+  vps->setMaxTLayers                       ( m_maxTempLayer );
+  if (m_maxTempLayer == 1)
+  {
+    vps->setTemporalNestingFlag(true);
+  }
+#if !VPS_RENAME
+  vps.setMaxLayers                        ( 1 );
+#endif
+  for(Int i = 0; i < MAX_TLAYER; i++)
+  {
+    vps->setNumReorderPics                 ( m_numReorderPics[i], i );
+    vps->setMaxDecPicBuffering             ( m_maxDecPicBuffering[i], i );
+  }
+
   for(UInt layer=0; layer<m_numLayers; layer++)
   {
-    TComVPS vps;
-
-    vps.setMaxTLayers                       ( m_maxTempLayer );
-    vps.setMaxLayers                        ( 1 );
-    for(Int i = 0; i < MAX_TLAYER; i++)
-    {
-      vps.setNumReorderPics                 ( m_numReorderPics[i], i );
-      vps.setMaxDecPicBuffering             ( m_maxDecPicBuffering[i], i );
-    }
-    m_acTEncTop[layer].setVPS(&vps);
+    //m_acTEncTop[layer].setVPS(&vps);
     m_acTEncTop[layer].setFrameRate                    ( m_acLayerCfg[layer].getFrameRate() );
     m_acTEncTop[layer].setFrameSkip                    ( m_FrameSkip );
     m_acTEncTop[layer].setSourceWidth                  ( m_acLayerCfg[layer].getSourceWidth() );
     m_acTEncTop[layer].setSourceHeight                 ( m_acLayerCfg[layer].getSourceHeight() );
-    m_acTEncTop[layer].setCroppingMode                 ( m_acLayerCfg[layer].getCroppingMode() );
-    m_acTEncTop[layer].setCropLeft                     ( m_acLayerCfg[layer].getCropLeft() );
-    m_acTEncTop[layer].setCropRight                    ( m_acLayerCfg[layer].getCropRight() );
-    m_acTEncTop[layer].setCropTop                      ( m_acLayerCfg[layer].getCropTop() );
-    m_acTEncTop[layer].setCropBottom                   ( m_acLayerCfg[layer].getCropBottom() );
-    m_acTEncTop[layer].setFrameToBeEncoded             ( m_iFrameToBeEncoded );
+    m_acTEncTop[layer].setConformanceMode              ( m_acLayerCfg[layer].getConformanceMode() );
+    m_acTEncTop[layer].setConformanceWindow            ( m_acLayerCfg[layer].m_confLeft, m_acLayerCfg[layer].m_confRight, m_acLayerCfg[layer].m_confTop, m_acLayerCfg[layer].m_confBottom );
+    m_acTEncTop[layer].setFramesToBeEncoded            ( m_framesToBeEncoded );
+
+    m_acTEncTop[layer].setProfile(m_profile);
+    m_acTEncTop[layer].setLevel(m_levelTier, m_level);
+#if L0046_CONSTRAINT_FLAGS
+    m_acTEncTop[layer].setProgressiveSourceFlag(m_progressiveSourceFlag);
+    m_acTEncTop[layer].setInterlacedSourceFlag(m_interlacedSourceFlag);
+    m_acTEncTop[layer].setNonPackedConstraintFlag(m_nonPackedConstraintFlag);
+    m_acTEncTop[layer].setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlag);
+#endif
 
 #if REF_IDX_MFM
-    if(layer == 0)
-    {
-      m_acTEncTop[layer].setMFMEnabledFlag(false);
-    }
-    else
-    {
-      m_acTEncTop[layer].setMFMEnabledFlag(true);
-    }
+    m_acTEncTop[layer].setMFMEnabledFlag(layer == 0 ? false : true);
 #endif
     // set layer ID 
@@ -112,5 +118,4 @@
     m_acTEncTop[layer].setNumLayer ( m_numLayers );
     m_acTEncTop[layer].setLayerEnc(m_apcTEncTop);
-
 
     //====== Coding Structure ========
@@ -134,9 +139,24 @@
 
     m_acTEncTop[layer].setMaxTempLayer                 ( m_maxTempLayer );
-#if !REMOVE_NSQT
-    m_acTEncTop[layer].setUseNSQT( m_enableNSQT );
-#endif
     m_acTEncTop[layer].setUseAMP( m_enableAMP );
-
+#if VPS_EXTN_DIRECT_REF_LAYERS
+    if(layer)
+    {
+      if(m_acLayerCfg[layer].getNumDirectRefLayers() == -1)
+      {
+        // Not included in the configuration file; assume that each layer depends on previous layer
+        m_acTEncTop[layer].setNumDirectRefLayers       (1);      // One ref. layer
+        m_acTEncTop[layer].setRefLayerId               (0, layer - 1);   // Previous layer
+      }
+      else
+      {
+        m_acTEncTop[layer].setNumDirectRefLayers       ( m_acLayerCfg[layer].getNumDirectRefLayers() );      
+        for(Int i = 0; i < m_acTEncTop[layer].getNumDirectRefLayers(); i++)
+        {
+          m_acTEncTop[layer].setRefLayerId             ( i, m_acLayerCfg[layer].getRefLayerId(i));
+        }        
+      }
+    }
+#endif
     //===== Slice ========
 
@@ -157,6 +177,6 @@
     m_acTEncTop[layer].setMaxCuDQPDepth                ( m_iMaxCuDQPDepth  );
 
-    m_acTEncTop[layer].setChromaCbQpOffset               ( m_cbQpOffset     );
-    m_acTEncTop[layer].setChromaCrQpOffset            ( m_crQpOffset  );
+    m_acTEncTop[layer].setChromaCbQpOffset             ( m_cbQpOffset     );
+    m_acTEncTop[layer].setChromaCrQpOffset             ( m_crQpOffset  );
 
 #if ADAPTIVE_QP_SELECTION
@@ -165,5 +185,5 @@
 
     Int lowestQP;
-    lowestQP =  - ( (Int)(6*(g_uiBitDepth + g_uiBitIncrement - 8)) );
+    lowestQP =  - 6*(g_bitDepthY - 8); // XXX: check
 
     if ((m_iMaxDeltaQP == 0 ) && (m_acLayerCfg[layer].getIntQP() == lowestQP) && (m_useLossless == true))
@@ -179,11 +199,12 @@
     m_acTEncTop[layer].setUseASR                       ( m_bUseASR      );
     m_acTEncTop[layer].setUseHADME                     ( m_bUseHADME    );
-#if !REMOVE_ALF
-    m_acTEncTop[layer].setUseALF                       ( m_bUseALF      );
-#endif
     m_acTEncTop[layer].setUseLossless                  ( m_useLossless );
     m_acTEncTop[layer].setUseLComb                     ( m_bUseLComb    );
-    m_acTEncTop[layer].setdQPs                         ( m_acLayerCfg[layer].getdQPs()        );
-    m_acTEncTop[layer].setUseRDOQ                      ( m_bUseRDOQ     );
+    m_acTEncTop[layer].setdQPs                         ( m_acLayerCfg[layer].getdQPs() );
+    m_acTEncTop[layer].setUseRDOQ                      ( m_useRDOQ     );
+    m_acTEncTop[layer].setUseRDOQTS                    ( m_useRDOQTS   );
+#if L0232_RD_PENALTY
+    m_acTEncTop[layer].setRDpenalty                    ( m_rdPenalty );
+#endif
     m_acTEncTop[layer].setQuadtreeTULog2MaxSize        ( m_uiQuadtreeTULog2MaxSize );
     m_acTEncTop[layer].setQuadtreeTULog2MinSize        ( m_uiQuadtreeTULog2MinSize );
@@ -193,14 +214,11 @@
     m_acTEncTop[layer].setUseEarlyCU                   ( m_bUseEarlyCU  ); 
     m_acTEncTop[layer].setUseFastDecisionForMerge      ( m_useFastDecisionForMerge  );
-    m_acTEncTop[layer].setUseCbfFastMode            ( m_bUseCbfFastMode  );
-    m_acTEncTop[layer].setUseEarlySkipDetection            ( m_useEarlySkipDetection );
-
-#if !REMOVE_LMCHROMA
-    m_acTEncTop[layer].setUseLMChroma                  ( m_bUseLMChroma );
-#endif
+    m_acTEncTop[layer].setUseCbfFastMode               ( m_bUseCbfFastMode  );
+    m_acTEncTop[layer].setUseEarlySkipDetection        ( m_useEarlySkipDetection );
+
     m_acTEncTop[layer].setUseTransformSkip             ( m_useTransformSkip      );
     m_acTEncTop[layer].setUseTransformSkipFast         ( m_useTransformSkipFast  );
     m_acTEncTop[layer].setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
-    m_acTEncTop[layer].setPCMLog2MinSize          ( m_uiPCMLog2MinSize);
+    m_acTEncTop[layer].setPCMLog2MinSize               ( m_uiPCMLog2MinSize);
     m_acTEncTop[layer].setUsePCM                       ( m_usePCM );
     m_acTEncTop[layer].setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
@@ -209,5 +227,5 @@
 
     //====== Weighted Prediction ========
-    m_acTEncTop[layer].setUseWP                   ( m_bUseWeightPred      );
+    m_acTEncTop[layer].setUseWP                   ( m_useWeightedPred      );
     m_acTEncTop[layer].setWPBiPred                ( m_useWeightedBiPred   );
     //====== Parallel Merge Estimation ========
@@ -215,43 +233,25 @@
 
     //====== Slice ========
-    m_acTEncTop[layer].setSliceMode               ( m_iSliceMode                );
-    m_acTEncTop[layer].setSliceArgument           ( m_iSliceArgument            );
+    m_acTEncTop[layer].setSliceMode               ( m_sliceMode                );
+    m_acTEncTop[layer].setSliceArgument           ( m_sliceArgument            );
 
     //====== Dependent Slice ========
-    m_acTEncTop[layer].setDependentSliceMode        ( m_iDependentSliceMode         );
-    m_acTEncTop[layer].setDependentSliceArgument    ( m_iDependentSliceArgument     );
-#if DEPENDENT_SLICES
-#if TILES_WPP_ENTROPYSLICES_FLAGS
-    m_acTEncTop[layer].setEntropySliceEnabledFlag   ( m_entropySliceEnabledFlag );
-#else
-    m_acTEncTop[layer].setCabacIndependentFlag      ( m_bCabacIndependentFlag   );
-#endif
-#endif
-    int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
-    if(m_iDependentSliceMode==SHARP_FIXED_NUMBER_OF_LCU_IN_DEPENDENT_SLICE)
-    {
-#if REMOVE_FGS
-      m_acTEncTop[layer].setDependentSliceArgument ( m_iDependentSliceArgument * iNumPartInCU );
-#else
-      m_acTEncTop[layer].setDependentSliceArgument ( m_iDependentSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
-#endif
-    }
-    if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_LCU_IN_SLICE)
-    {
-#if REMOVE_FGS
-      m_acTEncTop[layer].setSliceArgument ( m_iSliceArgument * iNumPartInCU );
-#else
-      m_acTEncTop[layer].setSliceArgument ( m_iSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
-#endif
-    }
-    if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_TILES_IN_SLICE)
-    {
-      m_acTEncTop[layer].setSliceArgument ( m_iSliceArgument );
-    }
-
-#if !REMOVE_FGS
-    m_acTEncTop[layer].setSliceGranularity        ( m_iSliceGranularity         );
-#endif
-    if(m_iSliceMode == 0 )
+    m_acTEncTop[layer].setSliceSegmentMode        ( m_sliceSegmentMode         );
+    m_acTEncTop[layer].setSliceSegmentArgument    ( m_sliceSegmentArgument     );
+    Int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
+    if(m_sliceSegmentMode==FIXED_NUMBER_OF_LCU)
+    {
+      m_acTEncTop[layer].setSliceSegmentArgument ( m_sliceSegmentArgument * iNumPartInCU );
+    }
+    if(m_sliceMode==FIXED_NUMBER_OF_LCU)
+    {
+      m_acTEncTop[layer].setSliceArgument ( m_sliceArgument * iNumPartInCU );
+    }
+    if(m_sliceMode==FIXED_NUMBER_OF_TILES)
+    {
+      m_acTEncTop[layer].setSliceArgument ( m_sliceArgument );
+    }
+
+    if(m_sliceMode == 0 )
     {
       m_bLFCrossSliceBoundaryFlag = true;
@@ -261,19 +261,22 @@
     m_acTEncTop[layer].setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
 
-#if SAO_LCU_BOUNDARY
     m_acTEncTop[layer].setSaoLcuBoundary (m_saoLcuBoundary);
-#endif
     m_acTEncTop[layer].setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
     m_acTEncTop[layer].setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
     m_acTEncTop[layer].setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
 
-    m_acTEncTop[layer].setDecodedPictureHashSEIEnabled(m_decodePictureHashSEIEnabled);
-#if RECOVERY_POINT_SEI
+    m_acTEncTop[layer].setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
     m_acTEncTop[layer].setRecoveryPointSEIEnabled( m_recoveryPointSEIEnabled );
-#endif
-#if BUFFERING_PERIOD_AND_TIMING_SEI
     m_acTEncTop[layer].setBufferingPeriodSEIEnabled( m_bufferingPeriodSEIEnabled );
     m_acTEncTop[layer].setPictureTimingSEIEnabled( m_pictureTimingSEIEnabled );
-#endif
+    m_acTEncTop[layer].setFramePackingArrangementSEIEnabled( m_framePackingSEIEnabled );
+    m_acTEncTop[layer].setFramePackingArrangementSEIType( m_framePackingSEIType );
+    m_acTEncTop[layer].setFramePackingArrangementSEIId( m_framePackingSEIId );
+    m_acTEncTop[layer].setFramePackingArrangementSEIQuincunx( m_framePackingSEIQuincunx );
+    m_acTEncTop[layer].setFramePackingArrangementSEIInterpretation( m_framePackingSEIInterpretation );
+    m_acTEncTop[layer].setDisplayOrientationSEIAngle( m_displayOrientationSEIAngle );
+    m_acTEncTop[layer].setTemporalLevel0IndexSEIEnabled( m_temporalLevel0IndexSEIEnabled );
+    m_acTEncTop[layer].setGradualDecodingRefreshInfoEnabled( m_gradualDecodingRefreshInfoEnabled );
+    m_acTEncTop[layer].setDecodingUnitInfoSEIEnabled( m_decodingUnitInfoSEIEnabled );
     m_acTEncTop[layer].setUniformSpacingIdr          ( m_iUniformSpacingIdr );
     m_acTEncTop[layer].setNumColumnsMinus1           ( m_iNumColumnsMinus1 );
@@ -281,6 +284,6 @@
     if(m_iUniformSpacingIdr==0)
     {
-      m_acTEncTop[layer].setColumnWidth              ( m_pchColumnWidth );
-      m_acTEncTop[layer].setRowHeight                ( m_pchRowHeight );
+      m_acTEncTop[layer].setColumnWidth              ( m_pColumnWidth );
+      m_acTEncTop[layer].setRowHeight                ( m_pRowHeight );
     }
     m_acTEncTop[layer].xCheckGSParameters();
@@ -297,19 +300,22 @@
     m_acTEncTop[layer].setScalingListFile            ( m_scalingListFile   );
     m_acTEncTop[layer].setSignHideFlag(m_signHideFlag);
-#if !REMOVE_ALF
-    m_acTEncTop[layer].setALFLowLatencyEncoding( m_alfLowLatencyEncoding );
-#endif
+#if RATE_CONTROL_LAMBDA_DOMAIN
+    m_acTEncTop[layer].setUseRateCtrl         ( m_RCEnableRateControl );
+    m_acTEncTop[layer].setTargetBitrate       ( m_RCTargetBitrate );
+    m_acTEncTop[layer].setKeepHierBit         ( m_RCKeepHierarchicalBit );
+    m_acTEncTop[layer].setLCULevelRC          ( m_RCLCULevelRC );
+    m_acTEncTop[layer].setUseLCUSeparateModel ( m_RCUseLCUSeparateModel );
+    m_acTEncTop[layer].setInitialQP           ( m_RCInitialQP );
+    m_acTEncTop[layer].setForceIntraQP        ( m_RCForceIntraQP );
+#else
     m_acTEncTop[layer].setUseRateCtrl     ( m_enableRateCtrl);
     m_acTEncTop[layer].setTargetBitrate   ( m_targetBitrate);
     m_acTEncTop[layer].setNumLCUInUnit    ( m_numLCUInUnit);
+#endif
     m_acTEncTop[layer].setTransquantBypassEnableFlag(m_TransquantBypassEnableFlag);
     m_acTEncTop[layer].setCUTransquantBypassFlagValue(m_CUTransquantBypassFlagValue);
-#if RECALCULATE_QP_ACCORDING_LAMBDA
     m_acTEncTop[layer].setUseRecalculateQPAccordingToLambda( m_recalculateQPAccordingToLambda );
-#endif
-#if ACTIVE_PARAMETER_SETS_SEI_MESSAGE
+    m_acTEncTop[layer].setUseStrongIntraSmoothing( m_useStrongIntraSmoothing );
     m_acTEncTop[layer].setActiveParameterSetsSEIEnabled ( m_activeParameterSetsSEIEnabled ); 
-#endif 
-#if SUPPORT_FOR_VUI
     m_acTEncTop[layer].setVuiParametersPresentFlag( m_vuiParametersPresentFlag );
     m_acTEncTop[layer].setAspectRatioIdc( m_aspectRatioIdc );
@@ -329,11 +335,41 @@
     m_acTEncTop[layer].setChromaSampleLocTypeBottomField( m_chromaSampleLocTypeBottomField );
     m_acTEncTop[layer].setNeutralChromaIndicationFlag( m_neutralChromaIndicationFlag );
+    m_acTEncTop[layer].setDefaultDisplayWindow( m_defDispWinLeftOffset, m_defDispWinRightOffset, m_defDispWinTopOffset, m_defDispWinBottomOffset );
+    m_acTEncTop[layer].setFrameFieldInfoPresentFlag( m_frameFieldInfoPresentFlag );
+    m_acTEncTop[layer].setPocProportionalToTimingFlag( m_pocProportionalToTimingFlag );
+    m_acTEncTop[layer].setNumTicksPocDiffOneMinus1   ( m_numTicksPocDiffOneMinus1    );
     m_acTEncTop[layer].setBitstreamRestrictionFlag( m_bitstreamRestrictionFlag );
     m_acTEncTop[layer].setTilesFixedStructureFlag( m_tilesFixedStructureFlag );
     m_acTEncTop[layer].setMotionVectorsOverPicBoundariesFlag( m_motionVectorsOverPicBoundariesFlag );
+    m_acTEncTop[layer].setMinSpatialSegmentationIdc( m_minSpatialSegmentationIdc );
     m_acTEncTop[layer].setMaxBytesPerPicDenom( m_maxBytesPerPicDenom );
     m_acTEncTop[layer].setMaxBitsPerMinCuDenom( m_maxBitsPerMinCuDenom );
     m_acTEncTop[layer].setLog2MaxMvLengthHorizontal( m_log2MaxMvLengthHorizontal );
     m_acTEncTop[layer].setLog2MaxMvLengthVertical( m_log2MaxMvLengthVertical );
+#if SIGNAL_BITRATE_PICRATE_IN_VPS
+    TComBitRatePicRateInfo *bitRatePicRateInfo = m_cTEncTop[layer].getVPS()->getBitratePicrateInfo();
+    // The number of bit rate/pic rate have to equal to number of sub-layers.
+    if(m_bitRatePicRateMaxTLayers)
+    {
+      assert(m_bitRatePicRateMaxTLayers == m_cTEncTop[layer].getVPS()->getMaxTLayers());
+    }
+    for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+    {
+      bitRatePicRateInfo->setBitRateInfoPresentFlag( i, m_bitRateInfoPresentFlag[i] );
+      if( bitRatePicRateInfo->getBitRateInfoPresentFlag(i) )
+      {
+        bitRatePicRateInfo->setAvgBitRate(i, m_avgBitRate[i]);
+        bitRatePicRateInfo->setMaxBitRate(i, m_maxBitRate[i]);
+      }
+    }
+    for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+    {
+      bitRatePicRateInfo->setPicRateInfoPresentFlag( i, m_picRateInfoPresentFlag[i] );
+      if( bitRatePicRateInfo->getPicRateInfoPresentFlag(i) )
+      {
+        bitRatePicRateInfo->setAvgPicRate     (i, m_avgPicRate[i]);
+        bitRatePicRateInfo->setConstantPicRateIdc(i, m_constantPicRateIdc[i]);
+      }
+    }
 #endif
 #if REF_IDX_FRAMEWORK
@@ -346,6 +382,10 @@
 {
   TComVPS vps;
-  
+
   vps.setMaxTLayers                       ( m_maxTempLayer );
+  if (m_maxTempLayer == 1)
+  {
+    vps.setTemporalNestingFlag(true);
+  }
   vps.setMaxLayers                        ( 1 );
   for(Int i = 0; i < MAX_TLAYER; i++)
@@ -355,15 +395,21 @@
   }
   m_cTEncTop.setVPS(&vps);
+
+  m_cTEncTop.setProfile(m_profile);
+  m_cTEncTop.setLevel(m_levelTier, m_level);
+#if L0046_CONSTRAINT_FLAGS
+  m_cTEncTop.setProgressiveSourceFlag(m_progressiveSourceFlag);
+  m_cTEncTop.setInterlacedSourceFlag(m_interlacedSourceFlag);
+  m_cTEncTop.setNonPackedConstraintFlag(m_nonPackedConstraintFlag);
+  m_cTEncTop.setFrameOnlyConstraintFlag(m_frameOnlyConstraintFlag);
+#endif
+
   m_cTEncTop.setFrameRate                    ( m_iFrameRate );
   m_cTEncTop.setFrameSkip                    ( m_FrameSkip );
   m_cTEncTop.setSourceWidth                  ( m_iSourceWidth );
   m_cTEncTop.setSourceHeight                 ( m_iSourceHeight );
-  m_cTEncTop.setCroppingMode                 ( m_croppingMode );
-  m_cTEncTop.setCropLeft                     ( m_cropLeft );
-  m_cTEncTop.setCropRight                    ( m_cropRight );
-  m_cTEncTop.setCropTop                      ( m_cropTop );
-  m_cTEncTop.setCropBottom                   ( m_cropBottom );
-  m_cTEncTop.setFrameToBeEncoded             ( m_iFrameToBeEncoded );
-  
+  m_cTEncTop.setConformanceWindow            ( m_confLeft, m_confRight, m_confTop, m_confBottom );
+  m_cTEncTop.setFramesToBeEncoded            ( m_framesToBeEncoded );
+
   //====== Coding Structure ========
   m_cTEncTop.setIntraPeriod                  ( m_iIntraPeriod );
@@ -382,15 +428,12 @@
   }
   m_cTEncTop.setQP                           ( m_iQP );
-  
+
   m_cTEncTop.setPad                          ( m_aiPad );
-    
+
   m_cTEncTop.setMaxTempLayer                 ( m_maxTempLayer );
-#if !REMOVE_NSQT
-  m_cTEncTop.setUseNSQT( m_enableNSQT );
-#endif
   m_cTEncTop.setUseAMP( m_enableAMP );
-  
+
   //===== Slice ========
-  
+
   //====== Loop/Deblock Filter ========
   m_cTEncTop.setLoopFilterDisable            ( m_bLoopFilterDisable       );
@@ -417,5 +460,5 @@
 
   Int lowestQP;
-  lowestQP =  - ( (Int)(6*(g_uiBitDepth + g_uiBitIncrement - 8)) );
+  lowestQP =  - 6*(g_bitDepthY - 8); // XXX: check
 
   if ((m_iMaxDeltaQP == 0 ) && (m_iQP == lowestQP) && (m_useLossless == true))
@@ -425,5 +468,5 @@
   m_cTEncTop.setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
   m_cTEncTop.setQPAdaptationRange            ( m_iQPAdaptationRange );
-  
+
   //====== Tool list ========
   m_cTEncTop.setUseSBACRD                    ( m_bUseSBACRD   );
@@ -431,11 +474,12 @@
   m_cTEncTop.setUseASR                       ( m_bUseASR      );
   m_cTEncTop.setUseHADME                     ( m_bUseHADME    );
-#if !REMOVE_ALF
-  m_cTEncTop.setUseALF                       ( m_bUseALF      );
-#endif
   m_cTEncTop.setUseLossless                  ( m_useLossless );
   m_cTEncTop.setUseLComb                     ( m_bUseLComb    );
   m_cTEncTop.setdQPs                         ( m_aidQP        );
-  m_cTEncTop.setUseRDOQ                      ( m_bUseRDOQ     );
+  m_cTEncTop.setUseRDOQ                      ( m_useRDOQ     );
+  m_cTEncTop.setUseRDOQTS                    ( m_useRDOQTS   );
+#if L0232_RD_PENALTY
+  m_cTEncTop.setRDpenalty                 ( m_rdPenalty );
+#endif
   m_cTEncTop.setQuadtreeTULog2MaxSize        ( m_uiQuadtreeTULog2MaxSize );
   m_cTEncTop.setQuadtreeTULog2MinSize        ( m_uiQuadtreeTULog2MinSize );
@@ -448,7 +492,4 @@
   m_cTEncTop.setUseEarlySkipDetection            ( m_useEarlySkipDetection );
 
-#if !REMOVE_LMCHROMA
-  m_cTEncTop.setUseLMChroma                  ( m_bUseLMChroma );
-#endif
   m_cTEncTop.setUseTransformSkip             ( m_useTransformSkip      );
   m_cTEncTop.setUseTransformSkipFast         ( m_useTransformSkipFast  );
@@ -458,8 +499,8 @@
   m_cTEncTop.setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
   m_cTEncTop.setMaxNumMergeCand              ( m_maxNumMergeCand );
-  
+
 
   //====== Weighted Prediction ========
-  m_cTEncTop.setUseWP                   ( m_bUseWeightPred      );
+  m_cTEncTop.setUseWP                   ( m_useWeightedPred      );
   m_cTEncTop.setWPBiPred                ( m_useWeightedBiPred   );
   //====== Parallel Merge Estimation ========
@@ -467,43 +508,25 @@
 
   //====== Slice ========
-  m_cTEncTop.setSliceMode               ( m_iSliceMode                );
-  m_cTEncTop.setSliceArgument           ( m_iSliceArgument            );
+  m_cTEncTop.setSliceMode               ( m_sliceMode                );
+  m_cTEncTop.setSliceArgument           ( m_sliceArgument            );
 
   //====== Dependent Slice ========
-  m_cTEncTop.setDependentSliceMode        ( m_iDependentSliceMode         );
-  m_cTEncTop.setDependentSliceArgument    ( m_iDependentSliceArgument     );
-#if DEPENDENT_SLICES
-#if TILES_WPP_ENTROPYSLICES_FLAGS
-  m_cTEncTop.setEntropySliceEnabledFlag   ( m_entropySliceEnabledFlag );
-#else
-  m_cTEncTop.setCabacIndependentFlag      ( m_bCabacIndependentFlag   );
-#endif
-#endif
-  int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
-  if(m_iDependentSliceMode==SHARP_FIXED_NUMBER_OF_LCU_IN_DEPENDENT_SLICE)
-  {
-#if REMOVE_FGS
-    m_cTEncTop.setDependentSliceArgument ( m_iDependentSliceArgument * iNumPartInCU );
-#else
-    m_cTEncTop.setDependentSliceArgument ( m_iDependentSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
-#endif
-  }
-  if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_LCU_IN_SLICE)
-  {
-#if REMOVE_FGS
-    m_cTEncTop.setSliceArgument ( m_iSliceArgument * iNumPartInCU );
-#else
-    m_cTEncTop.setSliceArgument ( m_iSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
-#endif
-  }
-  if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_TILES_IN_SLICE)
-  {
-    m_cTEncTop.setSliceArgument ( m_iSliceArgument );
-  }
-  
-#if !REMOVE_FGS
-  m_cTEncTop.setSliceGranularity        ( m_iSliceGranularity         );
-#endif
-  if(m_iSliceMode == 0 )
+  m_cTEncTop.setSliceSegmentMode        ( m_sliceSegmentMode         );
+  m_cTEncTop.setSliceSegmentArgument    ( m_sliceSegmentArgument     );
+  Int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
+  if(m_sliceSegmentMode==FIXED_NUMBER_OF_LCU)
+  {
+    m_cTEncTop.setSliceSegmentArgument ( m_sliceSegmentArgument * iNumPartInCU );
+  }
+  if(m_sliceMode==FIXED_NUMBER_OF_LCU)
+  {
+    m_cTEncTop.setSliceArgument ( m_sliceArgument * iNumPartInCU );
+  }
+  if(m_sliceMode==FIXED_NUMBER_OF_TILES)
+  {
+    m_cTEncTop.setSliceArgument ( m_sliceArgument );
+  }
+
+  if(m_sliceMode == 0 )
   {
     m_bLFCrossSliceBoundaryFlag = true;
@@ -513,19 +536,22 @@
   m_cTEncTop.setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
 
-#if SAO_LCU_BOUNDARY
   m_cTEncTop.setSaoLcuBoundary (m_saoLcuBoundary);
-#endif
   m_cTEncTop.setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
   m_cTEncTop.setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
   m_cTEncTop.setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
 
-  m_cTEncTop.setDecodedPictureHashSEIEnabled(m_decodePictureHashSEIEnabled);
-#if RECOVERY_POINT_SEI
+  m_cTEncTop.setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
   m_cTEncTop.setRecoveryPointSEIEnabled( m_recoveryPointSEIEnabled );
-#endif
-#if BUFFERING_PERIOD_AND_TIMING_SEI
   m_cTEncTop.setBufferingPeriodSEIEnabled( m_bufferingPeriodSEIEnabled );
   m_cTEncTop.setPictureTimingSEIEnabled( m_pictureTimingSEIEnabled );
-#endif
+  m_cTEncTop.setFramePackingArrangementSEIEnabled( m_framePackingSEIEnabled );
+  m_cTEncTop.setFramePackingArrangementSEIType( m_framePackingSEIType );
+  m_cTEncTop.setFramePackingArrangementSEIId( m_framePackingSEIId );
+  m_cTEncTop.setFramePackingArrangementSEIQuincunx( m_framePackingSEIQuincunx );
+  m_cTEncTop.setFramePackingArrangementSEIInterpretation( m_framePackingSEIInterpretation );
+  m_cTEncTop.setDisplayOrientationSEIAngle( m_displayOrientationSEIAngle );
+  m_cTEncTop.setTemporalLevel0IndexSEIEnabled( m_temporalLevel0IndexSEIEnabled );
+  m_cTEncTop.setGradualDecodingRefreshInfoEnabled( m_gradualDecodingRefreshInfoEnabled );
+  m_cTEncTop.setDecodingUnitInfoSEIEnabled( m_decodingUnitInfoSEIEnabled );
   m_cTEncTop.setUniformSpacingIdr          ( m_iUniformSpacingIdr );
   m_cTEncTop.setNumColumnsMinus1           ( m_iNumColumnsMinus1 );
@@ -533,6 +559,6 @@
   if(m_iUniformSpacingIdr==0)
   {
-    m_cTEncTop.setColumnWidth              ( m_pchColumnWidth );
-    m_cTEncTop.setRowHeight                ( m_pchRowHeight );
+    m_cTEncTop.setColumnWidth              ( m_pColumnWidth );
+    m_cTEncTop.setRowHeight                ( m_pRowHeight );
   }
   m_cTEncTop.xCheckGSParameters();
@@ -549,19 +575,22 @@
   m_cTEncTop.setScalingListFile            ( m_scalingListFile   );
   m_cTEncTop.setSignHideFlag(m_signHideFlag);
-#if !REMOVE_ALF
-  m_cTEncTop.setALFLowLatencyEncoding( m_alfLowLatencyEncoding );
-#endif
+#if RATE_CONTROL_LAMBDA_DOMAIN
+  m_cTEncTop.setUseRateCtrl         ( m_RCEnableRateControl );
+  m_cTEncTop.setTargetBitrate       ( m_RCTargetBitrate );
+  m_cTEncTop.setKeepHierBit         ( m_RCKeepHierarchicalBit );
+  m_cTEncTop.setLCULevelRC          ( m_RCLCULevelRC );
+  m_cTEncTop.setUseLCUSeparateModel ( m_RCUseLCUSeparateModel );
+  m_cTEncTop.setInitialQP           ( m_RCInitialQP );
+  m_cTEncTop.setForceIntraQP        ( m_RCForceIntraQP );
+#else
   m_cTEncTop.setUseRateCtrl     ( m_enableRateCtrl);
   m_cTEncTop.setTargetBitrate   ( m_targetBitrate);
   m_cTEncTop.setNumLCUInUnit    ( m_numLCUInUnit);
+#endif
   m_cTEncTop.setTransquantBypassEnableFlag(m_TransquantBypassEnableFlag);
   m_cTEncTop.setCUTransquantBypassFlagValue(m_CUTransquantBypassFlagValue);
-#if RECALCULATE_QP_ACCORDING_LAMBDA
   m_cTEncTop.setUseRecalculateQPAccordingToLambda( m_recalculateQPAccordingToLambda );
-#endif
-#if ACTIVE_PARAMETER_SETS_SEI_MESSAGE
+  m_cTEncTop.setUseStrongIntraSmoothing( m_useStrongIntraSmoothing );
   m_cTEncTop.setActiveParameterSetsSEIEnabled ( m_activeParameterSetsSEIEnabled ); 
-#endif 
-#if SUPPORT_FOR_VUI
   m_cTEncTop.setVuiParametersPresentFlag( m_vuiParametersPresentFlag );
   m_cTEncTop.setAspectRatioIdc( m_aspectRatioIdc );
